#ifndef DEF_COVER
#define DEF_COVER

#include <boost/dynamic_bitset.hpp>
#include <gecode/driver.hh>
#include <gecode/int.hh>
#include <gecode/set.hh>
#include "gecode/minimodel.hh"
#include <gecode/gist.hh>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <numeric>
#include <fstream>
#include <math.h>
#include <iostream>
#include <sstream> 
#include <vector>
#include <bitset>
#include <climits>
#include <stdio.h>


using namespace std;

typedef std::vector < int > VECELE;
typedef std::vector < VECELE > MATELE;

class Cover {
	
	public:
	
		/// Attributs
		VECELE Liste_Cover;
		VECELE Frequency;
		VECELE NotFreqItems; 		
		VECELE Closure;
		VECELE Inclusion;
		
		/// Methodes
		void Initial_Cover(VECELE t_value_0); // compute initial cover
		void Compute_New_Cover(VECELE item_prefix, VECELE t_value_0, Cover *nextCover); // compute the cover incrementaly 
		void Inclusion_test_00(VECELE t_value_0, VECELE sigma_0_new, VECELE sigma_01); // inclusion test case : p_k = 0 && sum = 0 
		void Inclusion_test_0(int minF, VECELE sigma_0_new, VECELE sigma_01); // inclusion test case : p_k = 0 && sum > 0 
		void Frequent_Closed_Itemsets(VECELE t_value_0, VECELE p_value_0, int minF, VECELE sigma_1, VECELE sigma_0, VECELE sigma_01); // Compute : (no frequent items) + (full extension items) + (items included in any item of sigma_0)
};

#endif //DEF_COVER
