#ifndef __GCCIM_HH__
#define __GCCIM_HH__

#include "Cover.h"
#include "Stack_Of_Cover.h"

extern int CurFreq; // frequency
extern double fminsup;
extern Cover coverD; // initial Cover which contains all transactions
Cover cover0; // instance of Cover class

Stack_Of_Cover Stack_Instance; // Instance of the classe representing the stack of pairs <cover, sigma_1>
VECELE sigma_0_Old; // Save sigma_0 to compute new items instaciated to 0 

namespace GCCIM {

void Cover_Incremental(VECELE sigma_1, VECELE sigma_0, VECELE sigma_01, VECELE t_value_0, VECELE p_value_0, int mins){
				
	while(!(Stack_Instance.Inlcus(sigma_1))){ // Descendre jusqu'a arriver à un point (sigma, cover) où le sommet de la pile Psigma_1 est inlcut dans sigma_1 courant
		Stack_Instance.Depiler_Cover_Sigma_1_();
	}	
	bool egal = Stack_Instance.Egaux(sigma_1);
	if(!egal){
		// instanciation à 1
		Cover *PPD_ = new Cover(); // pointeur sur la classe cover	
		VECELE new_Items;
		new_Items = Stack_Instance.Diffrence_Sigma_1(sigma_1); // Faire la diff entre sigma_1 et Psigma_1 (on sait pas quel/combien d'item(s) ont été ajoutés à sigma_1
		
		/**
		 * add t_value_0 in the call to compute the cover without t_value_0
		 **/		
		Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]->Compute_New_Cover(new_Items, t_value_0, PPD_); // Calcul couverture : intersection des cover de tous les news items	
		Stack_Instance.Emplier_Cover_Sigma_1_(PPD_,sigma_1); // Ajouter (Cover,sigma_1)
		
		// Les calculs des ensembles : NoFrequentItems, Closure et Inclusion pour filtrer
		Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]->Frequent_Closed_Itemsets(t_value_0, p_value_0, mins, sigma_1, sigma_0, sigma_01); // motifs clos
	}
}

using namespace std;
using namespace ::Gecode;
using namespace ::Gecode::Int;

template <class View>
class GCCIMConst : public NaryPropagator<View,PC_INT_DOM> {
	
	protected:
		using NaryPropagator<View,PC_INT_DOM>::x;
		ViewArray<View> P;
		ViewArray<View> T;
		ViewArray<View> P_0;
		ViewArray<View> T_0;
		int minsup;	
		int nbitems;
		int nbtransactions;	
		GCCIMConst(Space& home, ViewArray<View>& x, int nbitems0, int nbtransactions0, int freq0); // Constructor for posting		
		GCCIMConst(Space& home, bool share, GCCIMConst<View>& p); // Constructor for cloning \a p
  
	public:		
		virtual Actor* copy(Space& home, bool share); // Copy propagator during cloning
		// Perform propagation
		virtual ExecStatus propagate(Space& home, const ModEventDelta& med);
		virtual size_t dispose(Space& home);		
		static ExecStatus post(Space& home, ViewArray<View>& x, int nbitems0, int nbtransactions0, int minsup0); // Post propagator for view array \a x
};
  
/// Algorithme de filtrage :
template <class View> size_t GCCIMConst<View>::dispose(Space& home){    
   		
	for(unsigned int i=0; i < P.size(); i++)
		P[i].cancel(home, *this, PC_INT_DOM);
		
	for(unsigned int i=0; i < T.size(); i++)
		T[i].cancel(home, *this, PC_INT_DOM);
		
	for(unsigned int i=0; i < P_0.size(); i++)
		P_0[i].cancel(home, *this, PC_INT_DOM);
		
	for(unsigned int i=0; i < T_0.size(); i++)
		T_0[i].cancel(home, *this, PC_INT_DOM);
		
    (void)Propagator::dispose(home);
    return sizeof(*this);
};
template <class View>
	forceinline
	GCCIMConst<View>::GCCIMConst(Space& home, ViewArray<View>& x, int nbitems0, int nbtransactions0, int freq0): NaryPropagator<View,PC_INT_DOM>(home,x) {
		x.subscribe(home,*this,PC_INT_DOM);
		
		P = ViewArray<View>(home, nbitems0);					
		for(int i=0; i<nbitems0; i++)
			P[i] = x[i];
		
		T = ViewArray<View>(home, nbtransactions0);		
		for(int i=0; i<nbtransactions0; i++)
			T[i] = x[nbitems0+i];
			
		P_0 = ViewArray<View>(home, nbitems0);		
		for(int i=0; i<nbitems0; i++)
			P_0[i] = x[nbitems0+nbtransactions0+i];
			
		T_0 = ViewArray<View>(home, nbtransactions0);		
		for(int i=0; i<nbtransactions0; i++)
			T_0[i] = x[nbitems0+nbtransactions0+nbitems0+i];
		
		minsup = freq0;
		nbitems = nbitems0;
		nbtransactions = nbtransactions0;
	}	
// the copy-constructor to copy the propagator
template <class View>
	forceinline
	GCCIMConst<View>::GCCIMConst(Space& home, bool share, GCCIMConst<View>& p): 
	NaryPropagator<View,PC_INT_DOM>(home,share,p), P(x), T(x), P_0(x), T_0(x), nbitems(p.nbitems), nbtransactions(p.nbtransactions), minsup(p.minsup) {
		P.update(home,share,p.P);			
		T.update(home,share,p.T);			
		P_0.update(home,share,p.P_0);			
		T_0.update(home,share,p.T_0);			
	}	
template <class View>
	Actor*
	GCCIMConst<View>::copy(Space& home, bool share) {
		return new (home) GCCIMConst<View>(home,share,*this);
	}
template <class View>
	ExecStatus
	GCCIMConst<View>::post(Space& home, ViewArray<View>& x, int nbitems0, int nbtransactions0, int minsup0){
		(void) new (home) GCCIMConst<View>(home,x,nbitems0,nbtransactions0,minsup0);
		return ES_OK;
	}
/// Filtrage "Propagate()" : Propagateur appelé à chaque noeud
template <class View>
	ExecStatus
	GCCIMConst<View>::propagate(Space& home, const ModEventDelta&) { 
		
		Cover *PPD;
		VECELE sigma_1, sigma_0, sigma_01, T_Value, P_Value;
		T_Value.clear();
		int sum = 0;			
		int sum_T_0 = 0;			
	
		/*cout << " P_0 " << endl;
		for(unsigned int i = 0; i < P_0.size(); i++){
			cout << P_0[i] << "-";
		}cout << endl;
		cout << " T_0 " << endl;
		for(unsigned int i = 0; i < T_0.size(); i++){
			cout << T_0[i] << "-";
		}cout << endl;*/
	
	
		/**** Get pattern variables set to 0 in Dataset constraints ****/
		for(unsigned int i = 0; i < P_0.size(); i++){
			P_Value.push_back(1);
			if(P_0[i].assigned()){
				if(P_0[i].val() == 0)	
					P_Value[i]=0;
			}
		}		
		/***************************************************************/
		
		/** Get transaction variables set to 0 in Dataset constraints **/
		for(unsigned int i = 0; i < T_0.size(); i++){
			T_Value.push_back(1);
			if(T_0[i].assigned()){	
				if(T_0[i].val() == 0){
					T_Value[i]=0;
					sum_T_0++;
				}
			}
		}
		/***************************************************************/
				
		/**************** Get sigma_0, sigma_1, sigma_01 ***************/
		for(unsigned int i = 0; i < P.size(); i++){
			if(P_Value[i] != 0){
				if(P[i].assigned()){	
					sum = sum + P[i].val();	// Sum of instanciated variables					
					//sum++;	// Sum of instanciated variables					
					if(P[i].val() == 0) // value of the current instanciation 0 or 1
						sigma_0.push_back(i+1);
					else if(P[i].val() == 1)
						sigma_1.push_back(i+1);					
				}
				else{ // not instanciated variable
					sigma_01.push_back(i+1);
				}	
			}		
		}
		/***************************************************************/
		
		if(sum == 0){ // All variables instanciated to "1"	
							
			if(Stack_Instance.Covers_.empty()){ // no cover saved
				cover0.Initial_Cover(T_Value);
				Stack_Instance.Emplier_Cover_Sigma_1_(&cover0,sigma_1);// Add (initial cover, empty sigma)
			}
			// instanciation to 0
			PPD = Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]; // Last saved cover
			if((!sigma_0.empty())&&(!sigma_01.empty()))	{
				
				VECELE Diff_0; // new items instanciated to 0
				set_symmetric_difference(sigma_0_Old.begin(), sigma_0_Old.end(), sigma_0.begin(), sigma_0.end(), back_inserter(Diff_0));
				sigma_0_Old.clear();
				sigma_0_Old = sigma_0; // Update sigma_0_0 to compute next differences					
				// Delete items that appear in sigma_01
				for ( unsigned int j =0; j < Diff_0.size(); j++){
					if (find(sigma_0.begin(), sigma_0.end(), Diff_0[j]) == sigma_0.end()){ 
						Diff_0.erase(std::remove(Diff_0.begin(), Diff_0.end(), Diff_0[j]), Diff_0.end());
						j--;
					}		
				}									
				/** when an item is set to 0 => test if there is an inclusion **/
				PPD->Inclusion_test_00(T_Value, sigma_0, sigma_01); // Trouver les inclusions sur les nouveaux items mis à 0
				
				// Inclusion filtering
				if(sigma_0.size() + sigma_1.size() != P.size()){
					for(int g = 0; g < PPD->Inclusion.size(); g++){
						GECODE_ME_CHECK(P[PPD->Inclusion[g]-1].eq(home,0));
					}
				}
			}
			return ES_NOFIX;
		}
		else{
			// instanciation to 1
			minsup = round(fminsup*double(T.size()-sum_T_0)); // update minsup relative to the valid dataset
			Cover_Incremental(sigma_1, sigma_0, sigma_01, T_Value, P_Value, minsup); // Calculer le cover du sigma_1 actuel de manière incrementale sans inclure les t_i = 0
			PPD = Stack_Instance.Covers_[Stack_Instance.Covers_.size()-1]; //  
			
			/** Filtrage sur les transactions : transactions in cover are set to 1 **/
			/*for (int i = 0; i < PPD->Liste_Cover.size(); i++){
			//	if()
					GECODE_ME_CHECK(T[PPD->Liste_Cover[i]].eq(home, 1));
				//else
					//GECODE_ME_CHECK(T[PPD->Liste_Cover[i]].eq(home, 0));
			}*/
			for (int i = 0; i < T.size(); i++){
				if (find(PPD->Liste_Cover.begin(), PPD->Liste_Cover.end(), i) != PPD->Liste_Cover.end())
					GECODE_ME_CHECK(T[i].eq(home, 1));
				else{
					if(!T[i].assigned())	
						GECODE_ME_CHECK(T[i].eq(home, 0));
				}
			}
			
			// Si |Base projetée| < minsup => échec		
			CurFreq = PPD->Liste_Cover.size(); // Récuperer la fréquence d'un prefix : égale à la taille de son cover	
			if(CurFreq < minsup){
				return ES_FAILED;
			}
		
			/** Filtering when an item is set to 1 **/
			// Calcul cloture : items dont le cover est max : son cover contient que des "1"
			if (!PPD->Closure.empty()){
				for(unsigned int g = 0; g < PPD->Closure.size(); g++){
					GECODE_ME_CHECK(P[PPD->Closure[g]-1].eq(home, 1));
				}
			}			
			// Filtrer les items non fréquents + inclus
			if(sigma_0.size() + sigma_1.size() != P.size()){			
				// Get non-frequents items :
				for(int g = 0; g < PPD->NotFreqItems.size(); g++){					
					GECODE_ME_CHECK(P[PPD->NotFreqItems[g]-1].eq(home,0));
				}
				// Inclusions :
				for(int g = 0; g < PPD->Inclusion.size(); g++){					
					GECODE_ME_CHECK(P[PPD->Inclusion[g]-1].eq(home,0));
				}					
				return ES_NOFIX;					
			}			
			else{
				return home.ES_SUBSUMED(*this); // toutes les variables sont instanciées
			}			
		}
		delete PPD; // Détruire le pointeur...
	}
	
	void Closed_Itemset_Constraint(Space& home, const IntVarArgs& PP, const IntVarArgs& TT, const IntVarArgs& PP_0, const IntVarArgs& TT_0, int nbitems, int nbtransactions, int minsup) {

		if (home.failed())
			return;

		IntVarArgs BVA;
		BVA << PP;
		BVA << TT;
		BVA << PP_0;
		BVA << TT_0;
		ViewArray<IntView> xv(home,BVA);
		
		GECODE_ES_FAIL(GCCIM::GCCIMConst<IntView>::post(home,xv,nbitems,nbtransactions,minsup));
		
	}
}
#endif // __GCCIM_HH__
